/** Classe AbulEduMimeTypeV1
  *
  * @author 2012 Eric Seigne <eric.seigne@ryxeo.com>
  * @see The GNU Public License (GNU/GPL) v3
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 3 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
  * for more details.
  *
  * You should have received a copy of the GNU General Public License along
  * with this program. If not, see <http://www.gnu.org/licenses/>.
  */

#include "abuledumimetypev1.h"

#ifndef DEBUG_ABULEDUFILEV1
    #include <abuledudisableloggerv1.h>
#endif

AbulEduMimeTypeV1::AbulEduMimeTypeV1()
{
}

QHash<QString,QString> AbulEduMimeTypeV1::initialise()
{
    QHash<QString,QString> mimeTypes;
    //note: Généré automatiquement a partir du /etc/mime.types d'un gnu/linux :)
    mimeTypes.insert("ez","application/andrew-inset");
    mimeTypes.insert("anx","application/annodex");
    mimeTypes.insert("atom","application/atom+xml");
    mimeTypes.insert("atomcat","application/atomcat+xml");
    mimeTypes.insert("atomsrv","application/atomserv+xml");
    mimeTypes.insert("lin","application/bbolin");
    mimeTypes.insert("cap","application/cap");
    mimeTypes.insert("pcap","application/cap");
    mimeTypes.insert("cu","application/cu-seeme");
    mimeTypes.insert("davmount","application/davmount+xml");
    mimeTypes.insert("tsp","application/dsptype");
    mimeTypes.insert("es","application/ecmascript");
    mimeTypes.insert("spl","application/futuresplash");
    mimeTypes.insert("hta","application/hta");
    mimeTypes.insert("jar","application/java-archive");
    mimeTypes.insert("ser","application/java-serialized-object");
    mimeTypes.insert("class","application/java-vm");
    mimeTypes.insert("js","application/javascript");
    mimeTypes.insert("json","application/json");
    mimeTypes.insert("m3g","application/m3g");
    mimeTypes.insert("hqx","application/mac-binhex40");
    mimeTypes.insert("cpt","application/mac-compactpro");
    mimeTypes.insert("nb","application/mathematica");
    mimeTypes.insert("nbp","application/mathematica");
    mimeTypes.insert("mdb","application/msaccess");
    mimeTypes.insert("doc","application/msword");
    mimeTypes.insert("dot","application/msword");
    mimeTypes.insert("mxf","application/mxf");
    mimeTypes.insert("bin","application/octet-stream");
    mimeTypes.insert("oda","application/oda");
    mimeTypes.insert("ogx","application/ogg");
    mimeTypes.insert("one","application/onenote");
    mimeTypes.insert("onetoc2","application/onenote");
    mimeTypes.insert("onetmp","application/onenote");
    mimeTypes.insert("onepkg","application/onenote");
    mimeTypes.insert("pdf","application/pdf");
    mimeTypes.insert("key","application/pgp-keys");
    mimeTypes.insert("pgp","application/pgp-signature");
    mimeTypes.insert("prf","application/pics-rules");
    mimeTypes.insert("ps","application/postscript");
    mimeTypes.insert("ai","application/postscript");
    mimeTypes.insert("eps","application/postscript");
    mimeTypes.insert("epsi","application/postscript");
    mimeTypes.insert("epsf","application/postscript");
    mimeTypes.insert("eps2","application/postscript");
    mimeTypes.insert("eps3","application/postscript");
    mimeTypes.insert("rar","application/rar");
    mimeTypes.insert("rdf","application/rdf+xml");
    mimeTypes.insert("rss","application/rss+xml");
    mimeTypes.insert("rtf","application/rtf");
    mimeTypes.insert("stl","application/sla");
    mimeTypes.insert("smi","application/smil");
    mimeTypes.insert("smil","application/smil");
    mimeTypes.insert("xhtml","application/xhtml+xml");
    mimeTypes.insert("xht","application/xhtml+xml");
    mimeTypes.insert("xml","application/xml");
    mimeTypes.insert("xsl","application/xml");
    mimeTypes.insert("xsd","application/xml");
    mimeTypes.insert("xspf","application/xspf+xml");
    mimeTypes.insert("zip","application/zip");
    mimeTypes.insert("apk","application/vnd.android.package-archive");
    mimeTypes.insert("cdy","application/vnd.cinderella");
    mimeTypes.insert("kml","application/vnd.google-earth.kml+xml");
    mimeTypes.insert("kmz","application/vnd.google-earth.kmz");
    mimeTypes.insert("xul","application/vnd.mozilla.xul+xml");
    mimeTypes.insert("xls","application/vnd.ms-excel");
    mimeTypes.insert("xlb","application/vnd.ms-excel");
    mimeTypes.insert("xlt","application/vnd.ms-excel");
    mimeTypes.insert("xlam","application/vnd.ms-excel.addin.macroEnabled.12");
    mimeTypes.insert("xlsb","application/vnd.ms-excel.sheet.binary.macroEnabled.12");
    mimeTypes.insert("xlsm","application/vnd.ms-excel.sheet.macroEnabled.12");
    mimeTypes.insert("xltm","application/vnd.ms-excel.template.macroEnabled.12");
    mimeTypes.insert("thmx","application/vnd.ms-officetheme");
    mimeTypes.insert("cat","application/vnd.ms-pki.seccat");
    mimeTypes.insert("stl","#application/vnd.ms-pki.stl");
    mimeTypes.insert("ppt","application/vnd.ms-powerpoint");
    mimeTypes.insert("pps","application/vnd.ms-powerpoint");
    mimeTypes.insert("ppam","application/vnd.ms-powerpoint.addin.macroEnabled.12");
    mimeTypes.insert("pptm","application/vnd.ms-powerpoint.presentation.macroEnabled.12");
    mimeTypes.insert("sldm","application/vnd.ms-powerpoint.slide.macroEnabled.12");
    mimeTypes.insert("ppsm","application/vnd.ms-powerpoint.slideshow.macroEnabled.12");
    mimeTypes.insert("potm","application/vnd.ms-powerpoint.template.macroEnabled.12");
    mimeTypes.insert("docm","application/vnd.ms-word.document.macroEnabled.12");
    mimeTypes.insert("dotm","application/vnd.ms-word.template.macroEnabled.12");
    mimeTypes.insert("odc","application/vnd.oasis.opendocument.chart");
    mimeTypes.insert("odb","application/vnd.oasis.opendocument.database");
    mimeTypes.insert("odf","application/vnd.oasis.opendocument.formula");
    mimeTypes.insert("odg","application/vnd.oasis.opendocument.graphics");
    mimeTypes.insert("otg","application/vnd.oasis.opendocument.graphics-template");
    mimeTypes.insert("odi","application/vnd.oasis.opendocument.image");
    mimeTypes.insert("odp","application/vnd.oasis.opendocument.presentation");
    mimeTypes.insert("otp","application/vnd.oasis.opendocument.presentation-template");
    mimeTypes.insert("ods","application/vnd.oasis.opendocument.spreadsheet");
    mimeTypes.insert("ots","application/vnd.oasis.opendocument.spreadsheet-template");
    mimeTypes.insert("odt","application/vnd.oasis.opendocument.text");
    mimeTypes.insert("odm","application/vnd.oasis.opendocument.text-master");
    mimeTypes.insert("ott","application/vnd.oasis.opendocument.text-template");
    mimeTypes.insert("oth","application/vnd.oasis.opendocument.text-web");
    mimeTypes.insert("pptx","application/vnd.openxmlformats-officedocument.presentationml.presentation");
    mimeTypes.insert("sldx","application/vnd.openxmlformats-officedocument.presentationml.slide");
    mimeTypes.insert("ppsx","application/vnd.openxmlformats-officedocument.presentationml.slideshow");
    mimeTypes.insert("potx","application/vnd.openxmlformats-officedocument.presentationml.template");
    mimeTypes.insert("xlsx","application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
    mimeTypes.insert("xlsx","application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
    mimeTypes.insert("xltx","application/vnd.openxmlformats-officedocument.spreadsheetml.template");
    mimeTypes.insert("xltx","application/vnd.openxmlformats-officedocument.spreadsheetml.template");
    mimeTypes.insert("docx","application/vnd.openxmlformats-officedocument.wordprocessingml.document");
    mimeTypes.insert("dotx","application/vnd.openxmlformats-officedocument.wordprocessingml.template");
    mimeTypes.insert("cod","application/vnd.rim.cod");
    mimeTypes.insert("mmf","application/vnd.smaf");
    mimeTypes.insert("sdc","application/vnd.stardivision.calc");
    mimeTypes.insert("sds","application/vnd.stardivision.chart");
    mimeTypes.insert("sda","application/vnd.stardivision.draw");
    mimeTypes.insert("sdd","application/vnd.stardivision.impress");
    mimeTypes.insert("sdf","application/vnd.stardivision.math");
    mimeTypes.insert("sdw","application/vnd.stardivision.writer");
    mimeTypes.insert("sgl","application/vnd.stardivision.writer-global");
    mimeTypes.insert("sxc","application/vnd.sun.xml.calc");
    mimeTypes.insert("stc","application/vnd.sun.xml.calc.template");
    mimeTypes.insert("sxd","application/vnd.sun.xml.draw");
    mimeTypes.insert("std","application/vnd.sun.xml.draw.template");
    mimeTypes.insert("sxi","application/vnd.sun.xml.impress");
    mimeTypes.insert("sti","application/vnd.sun.xml.impress.template");
    mimeTypes.insert("sxm","application/vnd.sun.xml.math");
    mimeTypes.insert("sxw","application/vnd.sun.xml.writer");
    mimeTypes.insert("sxg","application/vnd.sun.xml.writer.global");
    mimeTypes.insert("stw","application/vnd.sun.xml.writer.template");
    mimeTypes.insert("sis","application/vnd.symbian.install");
    mimeTypes.insert("vsd","application/vnd.visio");
    mimeTypes.insert("wbxml","application/vnd.wap.wbxml");
    mimeTypes.insert("wmlc","application/vnd.wap.wmlc");
    mimeTypes.insert("wmlsc","application/vnd.wap.wmlscriptc");
    mimeTypes.insert("wpd","application/vnd.wordperfect");
    mimeTypes.insert("wp5","application/vnd.wordperfect5.1");
    mimeTypes.insert("wk","application/x-123");
    mimeTypes.insert("7z","application/x-7z-compressed");
    mimeTypes.insert("abw","application/x-abiword");
    mimeTypes.insert("dmg","application/x-apple-diskimage");
    mimeTypes.insert("bcpio","application/x-bcpio");
    mimeTypes.insert("torrent","application/x-bittorrent");
    mimeTypes.insert("cab","application/x-cab");
    mimeTypes.insert("cbr","application/x-cbr");
    mimeTypes.insert("cbz","application/x-cbz");
    mimeTypes.insert("cdf","application/x-cdf");
    mimeTypes.insert("cda","application/x-cdf");
    mimeTypes.insert("vcd","application/x-cdlink");
    mimeTypes.insert("pgn","application/x-chess-pgn");
    mimeTypes.insert("mph","application/x-comsol");
    mimeTypes.insert("cpio","application/x-cpio");
    mimeTypes.insert("csh","application/x-csh");
    mimeTypes.insert("deb","application/x-debian-package");
    mimeTypes.insert("udeb","application/x-debian-package");
    mimeTypes.insert("dcr","application/x-director");
    mimeTypes.insert("dir","application/x-director");
    mimeTypes.insert("dxr","application/x-director");
    mimeTypes.insert("dms","application/x-dms");
    mimeTypes.insert("wad","application/x-doom");
    mimeTypes.insert("dvi","application/x-dvi");
    mimeTypes.insert("pfa","application/x-font");
    mimeTypes.insert("pfb","application/x-font");
    mimeTypes.insert("gsf","application/x-font");
    mimeTypes.insert("pcf","application/x-font");
    mimeTypes.insert("pcf.Z","application/x-font");
    mimeTypes.insert("mm","application/x-freemind");
    mimeTypes.insert("spl","application/x-futuresplash");
    mimeTypes.insert("gan","application/x-ganttproject");
    mimeTypes.insert("gnumeric","application/x-gnumeric");
    mimeTypes.insert("sgf","application/x-go-sgf");
    mimeTypes.insert("gcf","application/x-graphing-calculator");
    mimeTypes.insert("gtar","application/x-gtar");
    mimeTypes.insert("tgz","application/x-gtar-compressed");
    mimeTypes.insert("taz","application/x-gtar-compressed");
    mimeTypes.insert("hdf","application/x-hdf");
    mimeTypes.insert("rhtml","application/x-httpd-eruby");
    mimeTypes.insert("phtml","application/x-httpd-php");
    mimeTypes.insert("pht","application/x-httpd-php");
    mimeTypes.insert("php","application/x-httpd-php");
    mimeTypes.insert("phps","application/x-httpd-php-source");
    mimeTypes.insert("php3","application/x-httpd-php3");
    mimeTypes.insert("php3p","application/x-httpd-php3-preprocessed");
    mimeTypes.insert("php4","application/x-httpd-php4");
    mimeTypes.insert("php5","application/x-httpd-php5");
    mimeTypes.insert("ica","application/x-ica");
    mimeTypes.insert("info","application/x-info");
    mimeTypes.insert("ins","application/x-internet-signup");
    mimeTypes.insert("isp","application/x-internet-signup");
    mimeTypes.insert("iii","application/x-iphone");
    mimeTypes.insert("iso","application/x-iso9660-image");
    mimeTypes.insert("jam","application/x-jam");
    mimeTypes.insert("jnlp","application/x-java-jnlp-file");
    mimeTypes.insert("jmz","application/x-jmol");
    mimeTypes.insert("chrt","application/x-kchart");
    mimeTypes.insert("kil","application/x-killustrator");
    mimeTypes.insert("skp","application/x-koan");
    mimeTypes.insert("skd","application/x-koan");
    mimeTypes.insert("skt","application/x-koan");
    mimeTypes.insert("skm","application/x-koan");
    mimeTypes.insert("kpr","application/x-kpresenter");
    mimeTypes.insert("kpt","application/x-kpresenter");
    mimeTypes.insert("ksp","application/x-kspread");
    mimeTypes.insert("kwd","application/x-kword");
    mimeTypes.insert("kwt","application/x-kword");
    mimeTypes.insert("latex","application/x-latex");
    mimeTypes.insert("lha","application/x-lha");
    mimeTypes.insert("lyx","application/x-lyx");
    mimeTypes.insert("lzh","application/x-lzh");
    mimeTypes.insert("lzx","application/x-lzx");
    mimeTypes.insert("frm","application/x-maker");
    mimeTypes.insert("maker","application/x-maker");
    mimeTypes.insert("frame","application/x-maker");
    mimeTypes.insert("fm","application/x-maker");
    mimeTypes.insert("fb","application/x-maker");
    mimeTypes.insert("book","application/x-maker");
    mimeTypes.insert("fbdoc","application/x-maker");
    mimeTypes.insert("mif","application/x-mif");
    mimeTypes.insert("m3u8","application/x-mpegURL");
    mimeTypes.insert("wmd","application/x-ms-wmd");
    mimeTypes.insert("wmz","application/x-ms-wmz");
    mimeTypes.insert("com","application/x-msdos-program");
    mimeTypes.insert("exe","application/x-msdos-program");
    mimeTypes.insert("bat","application/x-msdos-program");
    mimeTypes.insert("dll","application/x-msdos-program");
    mimeTypes.insert("msi","application/x-msi");
    mimeTypes.insert("nc","application/x-netcdf");
    mimeTypes.insert("pac","application/x-ns-proxy-autoconfig");
    mimeTypes.insert("dat","application/x-ns-proxy-autoconfig");
    mimeTypes.insert("nwc","application/x-nwc");
    mimeTypes.insert("o","application/x-object");
    mimeTypes.insert("oza","application/x-oz-application");
    mimeTypes.insert("p7r","application/x-pkcs7-certreqresp");
    mimeTypes.insert("crl","application/x-pkcs7-crl");
    mimeTypes.insert("pyc","application/x-python-code");
    mimeTypes.insert("pyo","application/x-python-code");
    mimeTypes.insert("qgs","application/x-qgis");
    mimeTypes.insert("shp","application/x-qgis");
    mimeTypes.insert("shx","application/x-qgis");
    mimeTypes.insert("qtl","application/x-quicktimeplayer");
    mimeTypes.insert("rdp","application/x-rdp");
    mimeTypes.insert("rpm","application/x-redhat-package-manager");
    mimeTypes.insert("rb","application/x-ruby");
    mimeTypes.insert("sci","application/x-scilab");
    mimeTypes.insert("sce","application/x-scilab");
    mimeTypes.insert("sh","application/x-sh");
    mimeTypes.insert("shar","application/x-shar");
    mimeTypes.insert("swf","application/x-shockwave-flash");
    mimeTypes.insert("swfl","application/x-shockwave-flash");
    mimeTypes.insert("scr","application/x-silverlight");
    mimeTypes.insert("sql","application/x-sql");
    mimeTypes.insert("sit","application/x-stuffit");
    mimeTypes.insert("sitx","application/x-stuffit");
    mimeTypes.insert("sv4cpio","application/x-sv4cpio");
    mimeTypes.insert("sv4crc","application/x-sv4crc");
    mimeTypes.insert("tar","application/x-tar");
    mimeTypes.insert("tcl","application/x-tcl");
    mimeTypes.insert("gf","application/x-tex-gf");
    mimeTypes.insert("pk","application/x-tex-pk");
    mimeTypes.insert("texinfo","application/x-texinfo");
    mimeTypes.insert("texi","application/x-texinfo");
    mimeTypes.insert("~","application/x-trash");
    mimeTypes.insert("%","application/x-trash");
    mimeTypes.insert("bak","application/x-trash");
    mimeTypes.insert("old","application/x-trash");
    mimeTypes.insert("sik","application/x-trash");
    mimeTypes.insert("t","application/x-troff");
    mimeTypes.insert("tr","application/x-troff");
    mimeTypes.insert("roff","application/x-troff");
    mimeTypes.insert("man","application/x-troff-man");
    mimeTypes.insert("me","application/x-troff-me");
    mimeTypes.insert("ms","application/x-troff-ms");
    mimeTypes.insert("ustar","application/x-ustar");
    mimeTypes.insert("src","application/x-wais-source");
    mimeTypes.insert("wz","application/x-wingz");
    mimeTypes.insert("crt","application/x-x509-ca-cert");
    mimeTypes.insert("xcf","application/x-xcf");
    mimeTypes.insert("fig","application/x-xfig");
    mimeTypes.insert("xpi","application/x-xpinstall");
    mimeTypes.insert("amr","audio/amr");
    mimeTypes.insert("awb","audio/amr-wb");
    mimeTypes.insert("amr","audio/amr");
    mimeTypes.insert("awb","audio/amr-wb");
    mimeTypes.insert("axa","audio/annodex");
    mimeTypes.insert("au","audio/basic");
    mimeTypes.insert("snd","audio/basic");
    mimeTypes.insert("csd","audio/csound");
    mimeTypes.insert("orc","audio/csound");
    mimeTypes.insert("sco","audio/csound");
    mimeTypes.insert("flac","audio/flac");
    mimeTypes.insert("mid","audio/midi");
    mimeTypes.insert("midi","audio/midi");
    mimeTypes.insert("kar","audio/midi");
    mimeTypes.insert("mpga","audio/mpeg");
    mimeTypes.insert("mpega","audio/mpeg");
    mimeTypes.insert("mp2","audio/mpeg");
    mimeTypes.insert("mp3","audio/mpeg");
    mimeTypes.insert("m4a","audio/mpeg");
    mimeTypes.insert("m3u","audio/mpegurl");
    mimeTypes.insert("oga","audio/ogg");
    mimeTypes.insert("ogg","audio/ogg");
    mimeTypes.insert("spx","audio/ogg");
    mimeTypes.insert("sid","audio/prs.sid");
    mimeTypes.insert("aif","audio/x-aiff");
    mimeTypes.insert("aiff","audio/x-aiff");
    mimeTypes.insert("aifc","audio/x-aiff");
    mimeTypes.insert("gsm","audio/x-gsm");
    mimeTypes.insert("m3u","audio/x-mpegurl");
    mimeTypes.insert("wma","audio/x-ms-wma");
    mimeTypes.insert("wax","audio/x-ms-wax");
    mimeTypes.insert("ra","audio/x-pn-realaudio");
    mimeTypes.insert("rm","audio/x-pn-realaudio");
    mimeTypes.insert("ram","audio/x-pn-realaudio");
    mimeTypes.insert("ra","audio/x-realaudio");
    mimeTypes.insert("pls","audio/x-scpls");
    mimeTypes.insert("sd2","audio/x-sd2");
    mimeTypes.insert("wav","audio/x-wav");
    mimeTypes.insert("alc","chemical/x-alchemy");
    mimeTypes.insert("cac","chemical/x-cache");
    mimeTypes.insert("cache","chemical/x-cache");
    mimeTypes.insert("csf","chemical/x-cache-csf");
    mimeTypes.insert("cbin","chemical/x-cactvs-binary");
    mimeTypes.insert("cascii","chemical/x-cactvs-binary");
    mimeTypes.insert("ctab","chemical/x-cactvs-binary");
    mimeTypes.insert("cdx","chemical/x-cdx");
    mimeTypes.insert("cer","chemical/x-cerius");
    mimeTypes.insert("c3d","chemical/x-chem3d");
    mimeTypes.insert("chm","chemical/x-chemdraw");
    mimeTypes.insert("cif","chemical/x-cif");
    mimeTypes.insert("cmdf","chemical/x-cmdf");
    mimeTypes.insert("cml","chemical/x-cml");
    mimeTypes.insert("cpa","chemical/x-compass");
    mimeTypes.insert("bsd","chemical/x-crossfire");
    mimeTypes.insert("csml","chemical/x-csml");
    mimeTypes.insert("csm","chemical/x-csml");
    mimeTypes.insert("ctx","chemical/x-ctx");
    mimeTypes.insert("cxf","chemical/x-cxf");
    mimeTypes.insert("cef","chemical/x-cxf");
    mimeTypes.insert("smi","#chemical/x-daylight-smiles");
    mimeTypes.insert("emb","chemical/x-embl-dl-nucleotide");
    mimeTypes.insert("embl","chemical/x-embl-dl-nucleotide");
    mimeTypes.insert("spc","chemical/x-galactic-spc");
    mimeTypes.insert("inp","chemical/x-gamess-input");
    mimeTypes.insert("gam","chemical/x-gamess-input");
    mimeTypes.insert("gamin","chemical/x-gamess-input");
    mimeTypes.insert("fch","chemical/x-gaussian-checkpoint");
    mimeTypes.insert("fchk","chemical/x-gaussian-checkpoint");
    mimeTypes.insert("cub","chemical/x-gaussian-cube");
    mimeTypes.insert("gau","chemical/x-gaussian-input");
    mimeTypes.insert("gjc","chemical/x-gaussian-input");
    mimeTypes.insert("gjf","chemical/x-gaussian-input");
    mimeTypes.insert("gal","chemical/x-gaussian-log");
    mimeTypes.insert("gcg","chemical/x-gcg8-sequence");
    mimeTypes.insert("gen","chemical/x-genbank");
    mimeTypes.insert("hin","chemical/x-hin");
    mimeTypes.insert("istr","chemical/x-isostar");
    mimeTypes.insert("ist","chemical/x-isostar");
    mimeTypes.insert("jdx","chemical/x-jcamp-dx");
    mimeTypes.insert("dx","chemical/x-jcamp-dx");
    mimeTypes.insert("kin","chemical/x-kinemage");
    mimeTypes.insert("mcm","chemical/x-macmolecule");
    mimeTypes.insert("mmd","chemical/x-macromodel-input");
    mimeTypes.insert("mmod","chemical/x-macromodel-input");
    mimeTypes.insert("mol","chemical/x-mdl-molfile");
    mimeTypes.insert("rd","chemical/x-mdl-rdfile");
    mimeTypes.insert("rxn","chemical/x-mdl-rxnfile");
    mimeTypes.insert("sd","chemical/x-mdl-sdfile");
    mimeTypes.insert("sdf","chemical/x-mdl-sdfile");
    mimeTypes.insert("tgf","chemical/x-mdl-tgf");
    mimeTypes.insert("mif","#chemical/x-mif");
    mimeTypes.insert("mcif","chemical/x-mmcif");
    mimeTypes.insert("mol2","chemical/x-mol2");
    mimeTypes.insert("b","chemical/x-molconn-Z");
    mimeTypes.insert("gpt","chemical/x-mopac-graph");
    mimeTypes.insert("mop","chemical/x-mopac-input");
    mimeTypes.insert("mopcrt","chemical/x-mopac-input");
    mimeTypes.insert("mpc","chemical/x-mopac-input");
    mimeTypes.insert("zmt","chemical/x-mopac-input");
    mimeTypes.insert("moo","chemical/x-mopac-out");
    mimeTypes.insert("mvb","chemical/x-mopac-vib");
    mimeTypes.insert("asn","chemical/x-ncbi-asn1");
    mimeTypes.insert("prt","chemical/x-ncbi-asn1-ascii");
    mimeTypes.insert("ent","chemical/x-ncbi-asn1-ascii");
    mimeTypes.insert("val","chemical/x-ncbi-asn1-binary");
    mimeTypes.insert("aso","chemical/x-ncbi-asn1-binary");
    mimeTypes.insert("asn","chemical/x-ncbi-asn1-spec");
    mimeTypes.insert("pdb","chemical/x-pdb");
    mimeTypes.insert("ent","chemical/x-pdb");
    mimeTypes.insert("ros","chemical/x-rosdal");
    mimeTypes.insert("sw","chemical/x-swissprot");
    mimeTypes.insert("vms","chemical/x-vamas-iso14976");
    mimeTypes.insert("vmd","chemical/x-vmd");
    mimeTypes.insert("xtel","chemical/x-xtel");
    mimeTypes.insert("xyz","chemical/x-xyz");
    mimeTypes.insert("gif","image/gif");
    mimeTypes.insert("ief","image/ief");
    mimeTypes.insert("jpeg","image/jpeg");
    mimeTypes.insert("jpg","image/jpeg");
    mimeTypes.insert("jpe","image/jpeg");
    mimeTypes.insert("pcx","image/pcx");
    mimeTypes.insert("png","image/png");
    mimeTypes.insert("svg","image/svg+xml");
    mimeTypes.insert("svgz","image/svg+xml");
    mimeTypes.insert("tiff","image/tiff");
    mimeTypes.insert("tif","image/tiff");
    mimeTypes.insert("djvu","image/vnd.djvu");
    mimeTypes.insert("djv","image/vnd.djvu");
    mimeTypes.insert("wbmp","image/vnd.wap.wbmp");
    mimeTypes.insert("cr2","image/x-canon-cr2");
    mimeTypes.insert("crw","image/x-canon-crw");
    mimeTypes.insert("ras","image/x-cmu-raster");
    mimeTypes.insert("cdr","image/x-coreldraw");
    mimeTypes.insert("pat","image/x-coreldrawpattern");
    mimeTypes.insert("cdt","image/x-coreldrawtemplate");
    mimeTypes.insert("cpt","image/x-corelphotopaint");
    mimeTypes.insert("erf","image/x-epson-erf");
    mimeTypes.insert("ico","image/x-icon");
    mimeTypes.insert("art","image/x-jg");
    mimeTypes.insert("jng","image/x-jng");
    mimeTypes.insert("bmp","image/x-ms-bmp");
    mimeTypes.insert("nef","image/x-nikon-nef");
    mimeTypes.insert("orf","image/x-olympus-orf");
    mimeTypes.insert("psd","image/x-photoshop");
    mimeTypes.insert("pnm","image/x-portable-anymap");
    mimeTypes.insert("pbm","image/x-portable-bitmap");
    mimeTypes.insert("pgm","image/x-portable-graymap");
    mimeTypes.insert("ppm","image/x-portable-pixmap");
    mimeTypes.insert("rgb","image/x-rgb");
    mimeTypes.insert("xbm","image/x-xbitmap");
    mimeTypes.insert("xpm","image/x-xpixmap");
    mimeTypes.insert("xwd","image/x-xwindowdump");
    mimeTypes.insert("eml","message/rfc822");
    mimeTypes.insert("igs","model/iges");
    mimeTypes.insert("iges","model/iges");
    mimeTypes.insert("msh","model/mesh");
    mimeTypes.insert("mesh","model/mesh");
    mimeTypes.insert("silo","model/mesh");
    mimeTypes.insert("wrl","model/vrml");
    mimeTypes.insert("vrml","model/vrml");
    mimeTypes.insert("x3dv","model/x3d+vrml");
    mimeTypes.insert("x3d","model/x3d+xml");
    mimeTypes.insert("x3db","model/x3d+binary");
    mimeTypes.insert("manifest","text/cache-manifest");
    mimeTypes.insert("ics","text/calendar");
    mimeTypes.insert("icz","text/calendar");
    mimeTypes.insert("css","text/css");
    mimeTypes.insert("csv","text/csv");
    mimeTypes.insert("323","text/h323");
    mimeTypes.insert("html","text/html");
    mimeTypes.insert("htm","text/html");
    mimeTypes.insert("shtml","text/html");
    mimeTypes.insert("uls","text/iuls");
    mimeTypes.insert("mml","text/mathml");
    mimeTypes.insert("asc","text/plain");
    mimeTypes.insert("txt","text/plain");
    mimeTypes.insert("text","text/plain");
    mimeTypes.insert("pot","text/plain");
    mimeTypes.insert("brf","text/plain");
    mimeTypes.insert("rtx","text/richtext");
    mimeTypes.insert("sct","text/scriptlet");
    mimeTypes.insert("wsc","text/scriptlet");
    mimeTypes.insert("tm","text/texmacs");
    mimeTypes.insert("tsv","text/tab-separated-values");
    mimeTypes.insert("jad","text/vnd.sun.j2me.app-descriptor");
    mimeTypes.insert("wml","text/vnd.wap.wml");
    mimeTypes.insert("wmls","text/vnd.wap.wmlscript");
    mimeTypes.insert("bib","text/x-bibtex");
    mimeTypes.insert("boo","text/x-boo");
    mimeTypes.insert("h++","text/x-c++hdr");
    mimeTypes.insert("hpp","text/x-c++hdr");
    mimeTypes.insert("hxx","text/x-c++hdr");
    mimeTypes.insert("hh","text/x-c++hdr");
    mimeTypes.insert("c++","text/x-c++src");
    mimeTypes.insert("cpp","text/x-c++src");
    mimeTypes.insert("cxx","text/x-c++src");
    mimeTypes.insert("cc","text/x-c++src");
    mimeTypes.insert("h","text/x-chdr");
    mimeTypes.insert("htc","text/x-component");
    mimeTypes.insert("csh","text/x-csh");
    mimeTypes.insert("c","text/x-csrc");
    mimeTypes.insert("d","text/x-dsrc");
    mimeTypes.insert("diff","text/x-diff");
    mimeTypes.insert("patch","text/x-diff");
    mimeTypes.insert("hs","text/x-haskell");
    mimeTypes.insert("java","text/x-java");
    mimeTypes.insert("lhs","text/x-literate-haskell");
    mimeTypes.insert("moc","text/x-moc");
    mimeTypes.insert("p","text/x-pascal");
    mimeTypes.insert("pas","text/x-pascal");
    mimeTypes.insert("gcd","text/x-pcs-gcd");
    mimeTypes.insert("pl","text/x-perl");
    mimeTypes.insert("pm","text/x-perl");
    mimeTypes.insert("py","text/x-python");
    mimeTypes.insert("scala","text/x-scala");
    mimeTypes.insert("etx","text/x-setext");
    mimeTypes.insert("sfv","text/x-sfv");
    mimeTypes.insert("sh","text/x-sh");
    mimeTypes.insert("tcl","text/x-tcl");
    mimeTypes.insert("tk","text/x-tcl");
    mimeTypes.insert("tex","text/x-tex");
    mimeTypes.insert("ltx","text/x-tex");
    mimeTypes.insert("sty","text/x-tex");
    mimeTypes.insert("cls","text/x-tex");
    mimeTypes.insert("vcs","text/x-vcalendar");
    mimeTypes.insert("vcf","text/x-vcard");
    mimeTypes.insert("3gp","video/3gpp");
    mimeTypes.insert("axv","video/annodex");
    mimeTypes.insert("dl","video/dl");
    mimeTypes.insert("dif","video/dv");
    mimeTypes.insert("dv","video/dv");
    mimeTypes.insert("fli","video/fli");
    mimeTypes.insert("gl","video/gl");
    mimeTypes.insert("mpeg","video/mpeg");
    mimeTypes.insert("mpg","video/mpeg");
    mimeTypes.insert("mpe","video/mpeg");
    mimeTypes.insert("ts","video/MP2T");
    mimeTypes.insert("mp4","video/mp4");
    mimeTypes.insert("qt","video/quicktime");
    mimeTypes.insert("mov","video/quicktime");
    mimeTypes.insert("ogv","video/ogg");
    mimeTypes.insert("webm","video/webm");
    mimeTypes.insert("mxu","video/vnd.mpegurl");
    mimeTypes.insert("flv","video/x-flv");
    mimeTypes.insert("lsf","video/x-la-asf");
    mimeTypes.insert("lsx","video/x-la-asf");
    mimeTypes.insert("mng","video/x-mng");
    mimeTypes.insert("asf","video/x-ms-asf");
    mimeTypes.insert("asx","video/x-ms-asf");
    mimeTypes.insert("wm","video/x-ms-wm");
    mimeTypes.insert("wmv","video/x-ms-wmv");
    mimeTypes.insert("wmx","video/x-ms-wmx");
    mimeTypes.insert("wvx","video/x-ms-wvx");
    mimeTypes.insert("avi","video/x-msvideo");
    mimeTypes.insert("movie","video/x-sgi-movie");
    mimeTypes.insert("mpv","video/x-matroska");
    mimeTypes.insert("mkv","video/x-matroska");
    mimeTypes.insert("ice","x-conference/x-cooltalk");
    mimeTypes.insert("sisx","x-epoc/x-sisx-app");
    mimeTypes.insert("vrm","x-world/x-vrml");
    mimeTypes.insert("vrml","x-world/x-vrml");
    mimeTypes.insert("wrl","x-world/x-vrml");
    return mimeTypes;
}

QString AbulEduMimeTypeV1::get(QString str)
{
    QHash<QString,QString> mimeTypes = AbulEduMimeTypeV1::initialise();
    return mimeTypes.value(str.toLower(),"inconnu");
}

QStringList AbulEduMimeTypeV1::getAll()
{
    QHash<QString,QString> mimeTypes = AbulEduMimeTypeV1::initialise();
    return mimeTypes.values();
}
